package com.jscape.inet.sftp.protocol.v4.marshaling;

import com.jscape.inet.sftp.protocol.messages.Message;
import com.jscape.inet.sftp.protocol.v4.messages.SshFxpRename;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshFxpRenameCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int id = Uint32Codec.readValue(in);
        String oldPath = StringCodec.readUtf8Value(in);
        String newPath = StringCodec.readUtf8Value(in);

        return new SshFxpRename(id, oldPath, newPath);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshFxpRename message = (SshFxpRename) value;
        Uint32Codec.writeValue(message.id, out);
        StringCodec.writeUtf8Value(message.oldPath, out);
        StringCodec.writeUtf8Value(message.newPath, out);
    }

}
